#ifndef PROFILER_H
#define PROFILER_H


#define PROFILER_INIT static u32 ham_prof_subticks=0; \
                          static u32 ham_prof_scanline_start,ham_prof_scanline_end; \
                          static u32 ham_prof_frames_elapsed; \
                          static u32 ham_prof_first_run=1; \
                          static u32 ticks_peak=0, ticks_cur_total=0;   \
                          static void ham_prof_timer3_int() \
                          { ham_prof_frames_elapsed++;  } \

#define PROFILER_START if(ham_prof_first_run)\
                            {\
                            ham_prof_first_run=0;\
                            }\
                            ham_prof_frames_elapsed=0;ham_prof_scanline_start=F_VCNT_CURRENT_SCANLINE; \
                            ham_StartIntHandler(INT_TYPE_TIM3,(void*)&ham_prof_timer3_int); \
                            M_TIM3COUNT_SET(65536-4399) \
                            M_TIM3CNT_SPEED_SELECT_SET(1) \
                            M_TIM3CNT_IRQ_ENABLE \
                            M_TIM3CNT_TIMER_START

#if defined(HEL_DEBUG) || defined(HEL_CHECKED)

#define PROFILER_END   ham_prof_scanline_end=F_VCNT_CURRENT_SCANLINE; \
                            M_TIM3CNT_TIMER_STOP \
                            ham_prof_subticks= F_TIM3COUNT_GET_CURRENT_VALUE - 61137; \
                            M_TIM3CNT_IRQ_DISABLE \
                            ticks_cur_total = ham_prof_subticks*(ham_prof_frames_elapsed+1); \
                            if(ticks_peak < ticks_cur_total) ticks_peak = ticks_cur_total;    \
                            HEL_DEBUG_MSG("F: %d T: %d\n", ham_prof_frames_elapsed, ham_prof_subticks);   \

#else

#define PROFILER_END   ham_prof_scanline_end=F_VCNT_CURRENT_SCANLINE; \
  M_TIM3CNT_TIMER_STOP \
  ham_prof_subticks= F_TIM3COUNT_GET_CURRENT_VALUE - 61137; \
  M_TIM3CNT_IRQ_DISABLE \
  ticks_cur_total = ham_prof_subticks*(ham_prof_frames_elapsed+1); \
  if(ticks_peak < ticks_cur_total) ticks_peak = ticks_cur_total;    \
  ham_DrawText(1,0,"F: %d T: %d ", ham_prof_frames_elapsed, ham_prof_subticks);   \
  ham_DrawText(1,1,"T Peak: %d ", ticks_peak);   \
  if(ham_prof_frames_elapsed > 0){\
  ham_DrawText(1,2,"Runs in 2nd frame!");   \
  while(1); \
  }

#endif



#endif /* _H */


/* END OF FILE */

