// -----------------------------------------------------------------------------
//
// Author(s):     Peter Schraut (www.console-dev.de)
// Last Modified: 10th August 2006
//
// Purpose:       Demo shows how to use the Splash-Screen System.
//
// -----------------------------------------------------------------------------
#include <hel2.h>
#include "ResourceData.h"

// Workmemory for Splash-Screen System
u8 ATTR_EWRAM ATTR_ALIGNED(4) g_SplashScreenSystemBuffer[HEL_SUBSYSTEM_SPLASH_REQUIREDMEMORY];


// -----------------------------------------------------------------------------
// Program Entry Point
// -----------------------------------------------------------------------------
int main(void)
{
    ham_Init();
    hel_SysSetPrefetch(TRUE);
    ham_SetBgMode(4);
    
    // Initialize Splash-Screen System
    hel_SplashInit((void*)g_SplashScreenSystemBuffer);

    for(;;)
    {
      // Display "Some Text" screen
      // Delays specified in milli-seconds (not very accurate)
      hel_Splash
         (
             ResData(RES_SPLASHTEXT_RAW), // pBitmap
             ResData(RES_SPLASHTEXT_PAL), // pPalette
             RGB_SET(0,0,0),              // InBlendColor
             RGB_SET(31,31,31),           // OutBlendColor
             60,                          // BlendDelay
             2000,                        // DisplayDelay
             500,                         // ContinueDelay
             COMPRESSION_TYPE_NONE,       // CompressionType,
             0                            // Flags
         );


      // Display "HEL" screen
      hel_Splash
         (
             ResData(RES_SPLASHHEL_RAW),  // pBitmap
             ResData(RES_SPLASHHEL_PAL),  // pPalette
             RGB_SET(31,31,31),           // InBlendColor
             RGB_SET(0,0,0),              // OutBlendColor
             60,                          // BlendDelay
             2000,                        // DisplayDelay
             500,                         // ContinueDelay
             COMPRESSION_TYPE_NONE,       // CompressionType,
             0                            // Flags
         );
    }
    
    // Uninitialize Splash-Screen System
    hel_SplashQuit();
    
    
    return 0;
}


